

!!! Listing 1

public abstract class Activation extends Throwable {

  private final Activation caller;
  protected Activation (Activation caller) { this.caller = caller; }

  public Object raise (Object info)
                         throws Activation, NullPointerException {
    return caller.raise(info);
  }

  protected final void handle (Object info) throws Activation {
    this.info = info;
    throw this;
  }

  private Object info;
  public final Object info () { return info; }
}

!!! Listing 2

 ... method (Activation caller, ...) throws Activation {

  final class MyActivation extends Activation {
    MyActivation (Activation caller) { super(caller); }

    ... <I>lokale Variablen fuer<I> method() <I>mit Zugriff fuer<I> raise()

    public Object raise (Object info) throws Activation {
      ... <I>entscheidet, wie mit<I> info <I>verfahren werden soll<I>
    }
  };
  final Activation self = new Activation(caller);

	  try {

    <I>... hier koennen andere Methoden aufgerufen werden und Probleme auftreten<I>

  } catch (Activation a) {
    if (a != self) throw a; Object info = self.info();

    <I>... hier wird<I> info <I>endgueltig verarbeitet, 
        wenn<I> raise() <I>das mit<I> handle() <I>verlangt<I>

  }
}

!!! Listing 3

A       method  A.. or raise, else return: <B>A<B>
AA      method  A.. or raise, else return: <B>B<B>
AAB     method  A.. or raise, else return:
        method  quits
AA      method  A.. or raise, else return: <B>raise<B>
AA      raise   super or handle, else return: <B>super<B>
A       raise   super or handle, else return: <B>super<B>  Fehler!
A       raise   super or handle, else return:
        raise   quits
AA      raise   super or handle, else return: <B>handle<B>
        method  handling AA
AA      method  A.. or raise, else return:
        method  quits
A       method  A.. or raise, else return:
        method  quits
