

!!! Listing 1

def dmap_f (seq, dict):
        return map (lambda x, d = dict: d[x],
                filter (lambda x, k = dict.keys (): x in k, seq))

!!! Listing 2

class simple_stack:
      def __init__ (self):
            self.st = []
      def push (self, x):
            self.st.append(x)
      def pop (self):
            del (self.st[-1])
      def top (self):
            return self.st[-1]
      def __len__ (self):
            return len (self.st)
      def __getitem__ (self, i):
            return self.st[i]
      def __repr__ (self):
            d = string.join (map
                  (lambda n: `n`, self), '\012')
            if d == '':
                  return '<stack empty>'
            else:
                  return ('<stack contents:\012'
                        + d + '\012>')
      def clear (self):
            del (self.st[:])

!!! Listing 3

class calc_stack (simple_stack):
      def take2 (self):
            p = (self.st[-1], self.st[-2])
            del (self.st[-2:])
            return p
      def xch (self):
            self.st[-1], self.st[-2] = (self.st[-2],
                  self.st[-1])
      def dup (self):
            self.st.append (self.st[-1])
      def add (self):
            (x, y) = self.take2 ()
            self.st.append (x + y)
      def mul (self):
            (x, y) = self.take2 ()
            self.st.append (x * y)
      def exp (self):
            (x, y) = self.take2 ()
            self.st.append (y ** x)       
      def sub (self):
            (x, y) = self.take2 ()
            self.st.append (y - x)
      def div (self):
            (x, y) = self.take2 ()
            self.st.append (y / x)
      def ru (self):
            self.st[:0] = [self.st[-1]]
            del (self.st[-1])
      def rd (self):
            self.st.append (self.st[0])
            del (self.st[0])

!!! Listing 4

class upn_calc:
      def __init__ (self):
            self.cs = calc_stack()
            self.choices = {
                  "+": self.cs.add,
                  "-": self.cs.sub,
                  "*": self.cs.mul,
                  "/": self.cs.div,
                  "de": self.cs.pop,
                  "xp": self.cs.exp,
                  "di": self.cs.__repr__,
                  "sw": self.cs.xch,
                  "du": self.cs.dup,
                  "cl": self.cs.clear,
                  "ru": self.cs.ru,
                  "rd": self.cs.rd}
      def command (self, s):
            try:
                  if s in self.choices.keys ():
                        r = apply (self.choices[s], ())
                  else:
                        r = self.cs.push (float (s))
                  if r == None:
                        r = self.cs.top ()
            except:
                  r = "illegal operand/operation"
            return r
