import java.awt.*;
import java.awt.event.*;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;

public class Controller extends Hashtable implements ActionListener, IO {
  private final Vector queue = new Vector();

  private synchronized void write (String s) {
    queue.addElement(s); notify();
  }

  private synchronized String read () {
    for (;;)
      try { wait(); break; } catch (InterruptedException e) { }
    String result = (String)queue.elementAt(0); queue.removeElementAt(0);
    return result;
  }

  private final Label stack = new Label("               ", Label.LEFT);
  { Frame f = new Frame(); f.setBackground(Color.darkGray);
    f.addWindowListener(new WindowAdapter() {
      public void windowClosing (WindowEvent e) { System.exit(1); }
    });

    f.setLayout(new BorderLayout(2,2));

    Panel p = new Panel(new BorderLayout());
      Label l = new Label("stack:  ", Label.RIGHT);
	l.setBackground(Color.lightGray);
      p.add(l, BorderLayout.WEST);
      p.add(stack, BorderLayout.CENTER); stack.setBackground(Color.lightGray);
    f.add(p, BorderLayout.SOUTH);

    View v; Model m;
    p = new Panel(new GridLayout(1,0, 2,2));	// can add many
      p.add(v = new View("A", this)); put("A", v); m = new Model("A", this);
      p.add(v = new View("B", this)); put("B", v); new Model("B", this);
      p.add(v = new View("C", this)); put("C", v); new Model("C", this);
    f.add(p, BorderLayout.CENTER);

    f.pack(); f.show();

    try {
      m.method(null);
    } catch (Activation x) { x.printStackTrace(); System.exit(1); }
    System.exit(0);
  }

  private void reset (boolean state) {
    Enumeration e = elements();
    while (e.hasMoreElements())
      ((View)e.nextElement()).reset(state);
  }

  public void actionPerformed (ActionEvent e) {
    write(e.getActionCommand());
  }

  public String inRaise (String stack, String name, int sum) {
    this.stack.setText(stack);
    reset(false); ((View)get(name)).callRaise(sum);
    return read();
  }

  public String inMethod (String stack, String name, int sum) {
    this.stack.setText(stack);
    reset(true); ((View)get(name)).callMethod(sum);
    return read();
  }

  public void setSum (String name, int sum) {
    ((View)get(name)).setSum(sum);
  }

  public void handleInfo (String name, int sum, Object info) {
    ((View)get(name)).reset(false);
    ((View)get(name)).callMethod(sum);
  }

  public void leaveRaise (String name) {
    ((View)get(name)).reset(false);
  }

  public void leaveMethod (String name) {
    ((View)get(name)).reset(false);
  }

  public static void main (String args []) {
    Controller c = new Controller();
  }
}
