#import "Controller.h"
#import "View.h"
#import "Model.h"

enum { empty, full };

@implementation Controller
- (void)awakeFromNib {
    map = [[NSDictionary dictionaryWithObjectsAndKeys:
					a, @"A", b, @"B", c, @"C", nil] retain];
    lock = [[NSConditionLock alloc] initWithCondition:empty];

    [[Model alloc] initWithName:@"B" io:self];
    [[Model alloc] initWithName:@"C" io:self];
    [NSThread detachNewThreadSelector:@selector(run:) toTarget:self
		withObject:[[Model alloc] initWithName:@"A" io:self]];
    [window makeKeyAndOrderFront:self];
    [NSApp activateIgnoringOtherApps:YES];
}

- (void)run:(Model*)model {
    NSAutoreleasePool * pool = [NSAutoreleasePool new];
    [model method:nil];
    [pool release];
    exit(0);	// [NSApp terminate:self] creates Bus error...
}

- (void)dealloc {
    [map release];
    [lock release];
    [super dealloc];
}

- (void)action:(NSString*)command {
    [lock lockWhenCondition:empty];
      queue = [command copy];
    [lock unlockWithCondition:full];
}

- (NSString*)read {
    NSString * result;
    [lock lockWhenCondition:full];
      result = [queue autorelease];
    [lock unlockWithCondition:empty];
    return result;
}

- (void)reset:(BOOL)flag {
    [a reset:flag]; [b reset:flag]; [c reset:flag];
}

- (NSString*)inRaise:(NSString*)_stack :(NSString*)name :(int)sum {
    [stack setStringValue:_stack];
    [self reset:NO];
    [(View*)[map objectForKey:name] callRaise:sum];
    return [self read];
}

- (NSString*)inMethod:(NSString*)_stack :(NSString*)name :(int)sum {
    [stack setStringValue:_stack];
    [self reset:TRUE];
    [(View*)[map objectForKey:name] callMethod:sum];
    return [self read];
}

- (void)setSum:(NSString*)name :(int)sum {
    [(View*)[map objectForKey:name] setSum:sum];
}

- (void)handleInfo:(NSString*)name :(int)sum :info {
    [(View*)[map objectForKey:name] reset:NO];
    [(View*)[map objectForKey:name] callMethod:sum];
}

- (void)leaveRaise:(NSString*)name {
    [(View*)[map objectForKey:name] reset:NO];
}

- (void)leaveMethod:(NSString*)name {
    [(View*)[map objectForKey:name] reset:NO];
}
@end
